
# CS 112 - Information Literacy for Former Engineering Majors

**Credits:** 1

The objective of this course is to enhance the ability of students to locate, manage, critically evaluate, and use information for problem solving, research, and decision making in a complex digital world. Emphasis in this course will be on information security, laws, regulations, institutional policies and ethical issues surrounding the access and use of information.


## Prerequisites

CEE 111 or ECE 111 or ENGT 111 or MAE 111 or MSIM 111 .


### Immediate Prereqs

  * CEE 111
  * ECE 111
  * ENGT 111
  * MAE 111
  * MSIM 111

### Indirect Prereqs

  * CEE 111
  * ECE 111
  * ENGT 111
  * MAE 111
  * MSIM 111


# CS 120G - Introduction to Information Literacy and Research

**Credits:** 3

Students will learn to locate, manage, critically evaluate and use information for problem solving, research and decision making. Includes collaborative tools for document development and office productivity tools for presentation. Information security, laws and etiquette related to use and access of information are covered.


## Prerequisites

None



# CS 121G - Introduction to Information Literacy and Research for Scientists

**Credits:** 3

Students will learn to locate, manage, critically evaluate and use information for scientific problem solving and research. Includes mathematical tools for data analysis and presentation and office and collaborative tools, as well. Information security, laws and etiquette related to use and access of information are covered.


## Prerequisites

None



# CS 126G - Honors: Introduction to Information Literacy and Research

**Credits:** 3

Open only to students in the Honors College. A special honors version of CS 120G .


## Prerequisites

None



# CS 133 - Introduction to Programming in Java

**Credits:** 4

Laboratory work required. Introduction to computer-based problem solving and programming in Java. Topics include problem solving methodologies, program design, algorithm development, and testing. Java language concepts include variables, data types and expressions, assignment, control-flow statements, functions, arrays, and classes. Algorithms covered include sorting, searching, and linked list manipulations.


## Prerequisites

MATH 102M or MATH 103M .


### Immediate Prereqs

  * MATH 102M or MATH 103M

### Indirect Prereqs

  * MATH 102M or MATH 103M


# CS 150 - Problem Solving and Programming I

**Credits:** 4

Laboratory work required. Introduction to computer-based problem solving and programming in C++. Topics include problem solving methodologies, program design, algorithm development, and testing. C++ language concepts include variables, data types and expressions, assignment, control-flow statements, functions, arrays, pointers, structs, and classes.


## Prerequisites

MATH 102M or MATH 103M or equivalent.


### Immediate Prereqs

  * MATH 102M or MATH 103M

### Indirect Prereqs

  * MATH 102M or MATH 103M

## (Directly) Required By

  * CS 170
  * CS 250
  * CS 252
  * CS 270
  * CS 333
  * CS 334
  * CS 381
  * CS 431/531
  * MATH 408/508

## (Indirectly) Required By

  * CS 170
  * CS 250
  * CS 252
  * CS 270
  * CS 312
  * CS 330
  * CS 333
  * CS 334
  * CS 350
  * CS 355
  * CS 361
  * CS 381
  * CS 382
  * CS 390
  * CS 410/510
  * CS 411W/511
  * CS 417/517
  * CS 418/518
  * CS 431/531
  * CS 432/532
  * CS 441/541
  * CS 450/550
  * CS 451/551
  * CS 455/555
  * CS 460/560
  * CS 471
  * CS 472
  * CS 475/575
  * CS 476/576
  * CS 478/578
  * CS 480/580
  * CS 487
  * CS 488/588
  * MATH 408/508


# CS 170 - Introduction to Computer Architecture I

**Credits:** 3

Fundamentals of the architecture and operation of modern computers. Basic computer logic: logic equations; gates; combinatorial logic. Basic computer arithmetic: binary numbers; floating point representation. System hierarchy, overview of a computer; integrated circuit technology. Performance: metrics; choosing benchmarks; Amdahl's law. Instruction Sets and Operations: assembly language; machine language; examples of other instruction sets.


## Prerequisites

MATH 102M or MATH 103M and a grade of C or better in CS 150 .


### Immediate Prereqs

  * CS 150
  * MATH 102M or MATH 103M

### Indirect Prereqs

  * CS 150
  * MATH 102M or MATH 103M

## (Directly) Required By

  * CS 270

## (Indirectly) Required By

  * CS 270
  * CS 455/555
  * CS 471
  * CS 487


# CS 195 - Topics

**Credits:** 1-3

Special topics in computer science that are not part of the current curriculum at the freshman/sophomore level.


## Prerequisites

None



# CS 250 - Problem Solving and Programming II

**Credits:** 4

Laboratory work required. Design issues arising in software systems and C++ programming techniques aiding in their solution. Topics include the software life cycle, methods of functional decomposition, design documentation, abstract data types and classes, common data structures, dynamic data structures, algorithmic patterns, and testing and debugging techniques. Term project required.


## Prerequisites

MATH 162M and a grade of C or better in CS 150 . Pre- or corequisite: CS 252 .


### Immediate Prereqs

  * CS 150
  * CS 252
  * MATH 162M

### Indirect Prereqs

  * CS 150
  * CS 252
  * CS 333
  * MATH 102M or MATH 103M
  * MATH 162M

## (Directly) Required By

  * CS 330
  * CS 355
  * CS 361
  * CS 382
  * CS 390
  * CS 417/517
  * CS 455/555

## (Indirectly) Required By

  * CS 330
  * CS 350
  * CS 355
  * CS 361
  * CS 382
  * CS 390
  * CS 410/510
  * CS 411W/511
  * CS 417/517
  * CS 418/518
  * CS 432/532
  * CS 441/541
  * CS 450/550
  * CS 451/551
  * CS 455/555
  * CS 460/560
  * CS 471
  * CS 472
  * CS 475/575
  * CS 476/576
  * CS 478/578
  * CS 480/580
  * CS 487
  * CS 488/588


# CS 252 - Introduction to Unix for Programmers

**Credits:** 1

Laboratory work required. Available for pass/fail grading only. An introduction to Unix with emphasis on the skills necessary to be a productive programmer in Unix, Linux, and related environments. Topics include command line shells, files and directories, editing, compiling and common command line utilities.


## Prerequisites

A grade of C or better in CS 150 , CS 333 , or IT 205 .


### Immediate Prereqs

  * CS 150
  * CS 333

### Indirect Prereqs

  * CS 150
  * CS 252
  * CS 333
  * MATH 102M or MATH 103M
  * MATH 163

## (Directly) Required By

  * CS 250
  * CS 312
  * CS 330
  * CS 333
  * CS 350
  * CS 355
  * CS 361
  * CS 450/550
  * CS 455/555

## (Indirectly) Required By

  * CS 250
  * CS 252
  * CS 270
  * CS 312
  * CS 330
  * CS 333
  * CS 350
  * CS 355
  * CS 361
  * CS 381
  * CS 382
  * CS 390
  * CS 410/510
  * CS 411W/511
  * CS 417/517
  * CS 418/518
  * CS 432/532
  * CS 441/541
  * CS 450/550
  * CS 451/551
  * CS 455/555
  * CS 460/560
  * CS 471
  * CS 472
  * CS 475/575
  * CS 476/576
  * CS 478/578
  * CS 480/580
  * CS 487
  * CS 488/588


# CS 270 - Introduction to Computer Architecture II

**Credits:** 3

Fundamentals of the architecture and operation of modern computers. Building an ALU. The cache-Ram interaction. The virtual memory system. The Fetch/Execute cycle. Implementing a set of the ALU, Load/Store and Branch instructions in a single cycle implementation. Basics of microprogramming. Design of the control unit. A pipelined implementation. Multicores, multiprocessors and clusters.


## Prerequisites

A grade of C or better in CS 170 and in either CS 150 or CS 333 .


### Immediate Prereqs

  * CS 150
  * CS 170
  * CS 333

### Indirect Prereqs

  * CS 150
  * CS 170
  * CS 252
  * CS 333
  * MATH 102M or MATH 103M
  * MATH 163

## (Directly) Required By

  * CS 455/555
  * CS 471
  * CS 487

## (Indirectly) Required By

  * CS 455/555
  * CS 471
  * CS 487


# CS 295 - Topics in Computer Science

**Credits:** 1-3

Special topics in computer science which are not part of the current curriculum at the freshman/sophomore level.


## Prerequisites

None



# CS 300T - Computers in Society

**Credits:** 3

Covers changes in the world's society due to continuing implementation of computing technologies. Evaluation of technological expansions in areas of governments, business/industry, education, medicine, transportation, communication and entertainment. Topics include: intellectual property, software piracy, computer crimes and ethics. Students must research a societal topic and present in written and oral forms.


## Prerequisites

ENGL 110C .


### Immediate Prereqs

  * ENGL 110C

### Indirect Prereqs

  * ENGL 110C

## (Directly) Required By

  * CS 410/510

## (Indirectly) Required By

  * CS 410/510


# CS 312 - Internet Concepts

**Credits:** 3

Laboratory work required. An in-depth introduction to the Internet and the World Wide Web for CS or similar majors as a basis for more advanced studies in Web programming. Topics include: historical and current development of the Internet Web document publishing. Internet design, communication, and application protocols and the tools that use them. Internet search tools and their design. Internet issues such as netiquette, copyright, spam, computer viruses, cookies, security, and future of the Internet.


## Prerequisites

CS 252 .


### Immediate Prereqs

  * CS 252

### Indirect Prereqs

  * CS 150
  * CS 252
  * CS 333
  * MATH 102M or MATH 103M
  * MATH 163

## (Directly) Required By

  * CS 418/518

## (Indirectly) Required By

  * CS 418/518


# CS 330 - Object-Oriented Programming and Design

**Credits:** 3

Laboratory work required. The techniques and idioms of object-oriented programming in C++ and Java. Methods of object-oriented analysis and design with the Unified Modeling Language. Multi-thread programs, synchronization, and graphic user interfaces.


## Prerequisites

MATH 163 , CS 252 and a grade of C or better in CS 250 or CS 333 .


### Immediate Prereqs

  * CS 250
  * CS 252
  * CS 333
  * MATH 163

### Indirect Prereqs

  * CS 150
  * CS 250
  * CS 252
  * CS 333
  * MATH 102M or MATH 103M
  * MATH 162M
  * MATH 163

## (Directly) Required By

  * CS 350
  * CS 411W/511
  * CS 418/518
  * CS 432/532
  * CS 441/541
  * CS 450/550
  * CS 451/551
  * CS 475/575
  * CS 476/576
  * CS 487

## (Indirectly) Required By

  * CS 350
  * CS 410/510
  * CS 411W/511
  * CS 418/518
  * CS 432/532
  * CS 441/541
  * CS 450/550
  * CS 451/551
  * CS 475/575
  * CS 476/576
  * CS 487


# CS 333 - Programming and Problem Solving in C++

**Credits:** 4

Laboratory work required. Topics include C++ syntax and semantics, principles of design and basic software engineering skills. This course satisfies the requirements of both CS 150 and 250. It is intended for the student who has already been introduced to programming, possibly in another language. This web-based course requires considerable maturity and independent responsibility on the part of the student.


## Prerequisites

MATH 163 and a grade of C or better in CS 150 or IT 210 (or an equivalent course in a high level language).  Pre- or corequisite: CS 252 .


### Immediate Prereqs

  * CS 150
  * CS 252
  * MATH 163

### Indirect Prereqs

  * CS 150
  * CS 252
  * CS 333
  * MATH 102M or MATH 103M
  * MATH 162M
  * MATH 163

## (Directly) Required By

  * CS 252
  * CS 270
  * CS 330
  * CS 355
  * CS 361
  * CS 381
  * CS 382
  * CS 390
  * CS 417/517
  * CS 455/555

## (Indirectly) Required By

  * CS 250
  * CS 252
  * CS 270
  * CS 312
  * CS 330
  * CS 333
  * CS 350
  * CS 355
  * CS 361
  * CS 381
  * CS 382
  * CS 390
  * CS 410/510
  * CS 411W/511
  * CS 417/517
  * CS 418/518
  * CS 432/532
  * CS 441/541
  * CS 450/550
  * CS 451/551
  * CS 455/555
  * CS 460/560
  * CS 471
  * CS 472
  * CS 475/575
  * CS 476/576
  * CS 478/578
  * CS 480/580
  * CS 487
  * CS 488/588


# CS 334 - Computer Architecture Fundamentals

**Credits:** 4

Topics include: number representation, base conversion, Boolean algebra, combinatorial circuits, arithmetic units, registers, memory, hardwired and microprogrammed control units, architecture of typical microcomputers, and the development of systems from basic components. The performance of competing architectures will be a major concern. This course satisfies the requirements of both CS 170 and CS 270 . This web-based course requires considerable maturity and independent responsibility on the part of the student.


## Prerequisites

MATH 163 and a grade of C or better in CS 150 (or an equivalent course in a high level language).


### Immediate Prereqs

  * CS 150
  * MATH 163

### Indirect Prereqs

  * CS 150
  * MATH 102M or MATH 103M
  * MATH 162M
  * MATH 163


# CS 350 - Introduction to Software Engineering

**Credits:** 3

Laboratory work required. An exploration of the software development process, with an emphasis on the tools and techniques that support project teams. Topics include: software development process models, requirements, automated testing, documentation, build, version and configuration management, issue tracking, and agile methods. The course requires each student to participate as a member of a project team and to demonstrate proficiency with a variety of development tools.


## Prerequisites

CS 252 and a grade of C or better in CS 330 or CS 361 .


### Immediate Prereqs

  * CS 252
  * CS 330
  * CS 361

### Indirect Prereqs

  * CS 150
  * CS 250
  * CS 252
  * CS 330
  * CS 333
  * CS 361
  * MATH 102M or MATH 103M
  * MATH 162M
  * MATH 163

## (Directly) Required By

  * CS 410/510

## (Indirectly) Required By

  * CS 410/510


# CS 355 - Principles of Programming Languages

**Credits:** 3

Survey of significant features of programming languages. Language types including imperative, functional, logical, and object-oriented are covered. Concepts include lexical and syntactic analysis, type systems, flow control, modularity, and parallel programming. Small programs in several languages required. Laboratory work required.


## Prerequisites

CS 252 and a grade of C or better in CS 250 or CS 333 .


### Immediate Prereqs

  * CS 250
  * CS 252
  * CS 333

### Indirect Prereqs

  * CS 150
  * CS 250
  * CS 252
  * CS 333
  * MATH 102M or MATH 103M
  * MATH 162M
  * MATH 163


# CS 361 - Data Structures and Algorithms

**Credits:** 3

Laboratory work required. Common abstract data types, including vectors, lists, stacks, queues, sets, maps, heaps, and graphs. Standard C++ interfaces for these ADTs. Generic programming via iterators and templates. Choosing data structures and algorithms to implement ADTs, via analysis of their time and space complexity.


## Prerequisites

MATH 163 , CS 252 and a grade of C or better in CS 250 or CS 333 .


### Immediate Prereqs

  * CS 250
  * CS 252
  * CS 333
  * MATH 163

### Indirect Prereqs

  * CS 150
  * CS 250
  * CS 252
  * CS 333
  * MATH 102M or MATH 103M
  * MATH 162M
  * MATH 163

## (Directly) Required By

  * CS 350
  * CS 432/532
  * CS 450/550
  * CS 451/551
  * CS 460/560
  * CS 471
  * CS 472
  * CS 475/575
  * CS 476/576
  * CS 478/578
  * CS 480/580
  * CS 487
  * CS 488/588

## (Indirectly) Required By

  * CS 350
  * CS 410/510
  * CS 432/532
  * CS 450/550
  * CS 451/551
  * CS 460/560
  * CS 471
  * CS 472
  * CS 475/575
  * CS 476/576
  * CS 478/578
  * CS 480/580
  * CS 487
  * CS 488/588


# CS 367 - Cooperative Education

**Credits:** 1-3

Available for pass/fail grading only. Student participation for credit based on the academic relevance of the work experience, criteria, and evaluative procedures as formally determined by the department and Career Development Services prior to the semester in which the work experience is to take place. Written report required.


## Prerequisites

approval by the CS Department and Career Development Services in accordance with the policy for granting credit for Cooperative Education programs.



# CS 368 - Computer Science Internship

**Credits:** 1-3

Available for pass/fail grading only. Academic requirements will be established by the department and will vary with the amount of credit desired. Allows students to gain short duration career-related experience. An academic project may be required by the department to enhance the value of the educational experience. Written report required.


## Prerequisites

approval by CS Department and Career Development Services.



# CS 381 - Introduction to Discrete Structures

**Credits:** 3

Topics include propositional and predicate logic, rules of inference, methods of proof, set operations, functions, complexity of algorithms, growth of functions, induction, counting, relations, equivalence relations and graphs.


## Prerequisites

MATH 163 and a grade of C or better in CS 150 or CS 333 .


### Immediate Prereqs

  * CS 150
  * CS 333
  * MATH 163

### Indirect Prereqs

  * CS 150
  * CS 252
  * CS 333
  * MATH 102M or MATH 103M
  * MATH 162M
  * MATH 163

## (Directly) Required By

  * CS 390
  * CS 450/550

## (Indirectly) Required By

  * CS 390
  * CS 450/550


# CS 382 - Introduction to JAVA

**Credits:** 1

Laboratory work required. An introduction to the Java programming language for students who are familiar with programming in C++. Topics include basic language syntax, data structures, control flow, classes, exception handling, and basic elements of the Java API. This web-based class requires independent responsibility and online communication skills on the part of the student.


## Prerequisites

A grade of C or better in CS 250 or CS 333 .


### Immediate Prereqs

  * CS 250
  * CS 333

### Indirect Prereqs

  * CS 150
  * CS 250
  * CS 252
  * CS 333
  * MATH 102M or MATH 103M
  * MATH 162M
  * MATH 163

## (Directly) Required By

  * CS 441/541

## (Indirectly) Required By

  * CS 441/541


# CS 390 - Introduction to Theoretical Computer Science

**Credits:** 3

Elementary study of theoretical aspects of computer science. Topics in formal languages and automata theory are covered including regular languages, regular expressions, finite automata, context-free languages, pushdown automata, grammars, Turing machines, and unsolvable problems.


## Prerequisites

A grade of C or better in CS 381 and CS 250 or CS 333 .


### Immediate Prereqs

  * CS 250
  * CS 333
  * CS 381

### Indirect Prereqs

  * CS 150
  * CS 250
  * CS 252
  * CS 333
  * CS 381
  * MATH 102M or MATH 103M
  * MATH 162M
  * MATH 163


# CS 395 - Topics in Computer Science

**Credits:** 1-3

Special topics in computer science that are not part of the current curriculum at the junior/senior level.


## Prerequisites

permission of the instructor.



# CS 410/510 - Professional Workforce Development I

**Credits:** 3

Laboratory work required. Provides students with challenges of business environments in developing a technology based project. Students identify a societal problem, identify solutions, define project solutions, develop project objectives, conduct feasibility analysis, establish organizational group structure to meet project objectives and develop formal specifications. Students make formal technical project presentations and develop web documentation. Students prepare a draft grant proposal.


## Prerequisites

A grade of C or better in CS 300T and CS 350 .


### Immediate Prereqs

  * CS 300T
  * CS 350

### Indirect Prereqs

  * CS 150
  * CS 250
  * CS 252
  * CS 300T
  * CS 330
  * CS 333
  * CS 350
  * CS 361
  * ENGL 110C
  * MATH 102M or MATH 103M
  * MATH 162M
  * MATH 163


# CS 411W/511 - Professional Workforce Development II

**Credits:** 3

Laboratory work required. Students write professional and non-technical documents and continue the development of the project defined in CS 410 . Written work is reviewed and returned for corrective rewriting. Students will design and develop a project prototype, and demonstrate the prototype to a formal panel along with delivering the formal product specifications and a draft formal grant proposal. This is a writing intensive course.


## Prerequisites

A grade of C or better in ENGL 211C or ENGL 221C or ENGL 231C and a grade of C or better in CS 330 and CS 410 .


### Immediate Prereqs

  * CS 330
  * CS 410
  * ENGL 211C
  * ENGL 221C
  * ENGL 231C

### Indirect Prereqs

  * CS 150
  * CS 250
  * CS 252
  * CS 330
  * CS 333
  * CS 410
  * ENGL 110C
  * ENGL 211C
  * ENGL 221C
  * ENGL 231C
  * MATH 102M or MATH 103M
  * MATH 162M
  * MATH 163


# CS 417/517 - Computational Methods and Software

**Credits:** 3

Laboratory work required. Algorithms and software for fundamental problems in scientific computing. Topics: properties of floating point arithmetic, linear systems of equations, matrix factorizations, stability of algorithms, conditioning of problems, least-squares problems, eigenvalue computations, numerical integration and differentiation, nonlinear equations, iterative solution of linear systems.


## Prerequisites

MATH 316 and a grade of C or better in CS 250 or CS 333 .


### Immediate Prereqs

  * CS 250
  * CS 333
  * MATH 316

### Indirect Prereqs

  * CS 150
  * CS 250
  * CS 252
  * CS 333
  * MATH 102M or MATH 103M
  * MATH 162M
  * MATH 163
  * MATH 212
  * MATH 316


# CS 418/518 - Web Programming

**Credits:** 3

Laboratory work required. Overview of Internet and World Wide Web; web servers and security, HTTP protocol; web application and design; server side scripts and database integration, and programming for the Web.


## Prerequisites

A grade of C or better in CS 312 and CS 330 .


### Immediate Prereqs

  * CS 312
  * CS 330

### Indirect Prereqs

  * CS 150
  * CS 250
  * CS 252
  * CS 312
  * CS 330
  * CS 333
  * MATH 102M or MATH 103M
  * MATH 162M
  * MATH 163


# CS 431/531 - Web Server Design

**Credits:** 3

Laboratory work required. Extensive coverage of the hypertext transfer protocol (HTTP), specifications and commentary (IETF RFCs), and implications for servers and clients. Students will develop a web server providing common HTTP functionality and implementing all HTTP (including unsafe and conditional) methods, content negotiation, transfer and content encoding, basic & digest authentication, and server-side execution of programs (i.e., dynamic resources). Frequent in-class demonstrations of progress and protocol conformance will be required.


## Prerequisites

CS 150 , familiarity with Internet and network (including socket) programming.


### Immediate Prereqs

  * CS 150

### Indirect Prereqs

  * CS 150
  * MATH 102M or MATH 103M


# CS 432/532 - Web Science

**Credits:** 3

Provides an overview of the World Wide Web and associated decentralized information structures, focusing mainly on the computing aspects of the Web: how it works, how it is used, and how it can be analyzed. Students will examine a number of topics including: web architecture, web characterization and analysis, web archiving, Web 2.0, social networks, collective intelligence, search engines, web mining, information diffusion on the web, and the Semantic Web.


## Prerequisites

A grade of C or better in CS 361 and CS 330 .


### Immediate Prereqs

  * CS 330
  * CS 361

### Indirect Prereqs

  * CS 150
  * CS 250
  * CS 252
  * CS 330
  * CS 333
  * CS 361
  * MATH 102M or MATH 103M
  * MATH 162M
  * MATH 163


# CS 441/541 - App Development for Smart Devices

**Credits:** 3

Laboratory work required. Project-oriented coverage of the principles of application design and development for Android platform smart devices. Topics include user interface; input methods; data handling; network techniques; localization and sensing. Students are required to produce a professional-quality mobile application.


## Prerequisites

CS 330 or CS 382 .


### Immediate Prereqs

  * CS 330
  * CS 382

### Indirect Prereqs

  * CS 150
  * CS 250
  * CS 252
  * CS 330
  * CS 333
  * CS 382
  * MATH 102M or MATH 103M
  * MATH 162M
  * MATH 163


# CS 450/550 - Database Concepts

**Credits:** 3

Laboratory work required. Three level database architecture. The relational database model and relational algebra. SQL and its use in database procedures and with conventional programming languages. Entity relationship modeling. Functional dependencies and normalization. Transactions, concurrency and recovery.


## Prerequisites

CS 252 and a grade of C or better in CS 381 and either CS 330 or CS 361 .


### Immediate Prereqs

  * CS 252
  * CS 330
  * CS 361
  * CS 381

### Indirect Prereqs

  * CS 150
  * CS 250
  * CS 252
  * CS 330
  * CS 333
  * CS 361
  * CS 381
  * MATH 102M or MATH 103M
  * MATH 162M
  * MATH 163


# CS 451/551 - Software Engineering Survey

**Credits:** 3

Laboratory work required. Evaluation of software development methodologies. Topics include: software life cycle models, software specification and design methodologies, informal specification techniques, formal specifications, design tools, software analysis, quality assurance, life cycle management, software costing models and complexity.


## Prerequisites

A grade of C or better in CS 330 or CS 361 .


### Immediate Prereqs

  * CS 330
  * CS 361

### Indirect Prereqs

  * CS 150
  * CS 250
  * CS 252
  * CS 330
  * CS 333
  * CS 361
  * MATH 102M or MATH 103M
  * MATH 162M
  * MATH 163


# CS 454/554 - Network Management

**Credits:** 3

Laboratory work required. The administration of computer networks and their interaction with wide area networks: network topologies for local and wide area networks, common protocols and services, management of distributed file services, routing and configuration, security, monitoring and trouble-shooting.


## Prerequisites

A grade of C or better in CS 455 .


### Immediate Prereqs

  * CS 455

### Indirect Prereqs

  * CS 455


# CS 455/555 - Introduction to Networks and Communications

**Credits:** 3

Internet and the 5-layered protocol architecture for the Internet, applications built on top of data networks, specifically the Internet, the web, the transport layer, TCP and UDP protocols, the network layer, the data link layer, also some of the technologies for the physical layer.


## Prerequisites

CS 250 or CS 333 , CS 252 , CS 270 .


### Immediate Prereqs

  * CS 250
  * CS 252
  * CS 270
  * CS 333

### Indirect Prereqs

  * CS 150
  * CS 170
  * CS 250
  * CS 252
  * CS 270
  * CS 333
  * MATH 102M or MATH 103M
  * MATH 162M
  * MATH 163


# CS 458/558 - Unix System Administration

**Credits:** 3

Laboratory work required. Aspects of administering a SOLARIS/UNIX operating system in a networked environment are covered. Topics covered include installation, file system management, backup procedures, process control, user administration, device management, Network File Systems (NFS), Network Information Systems (NIS), UNIX security, Domain Name Services (DNS), and integration with other operating systems.


## Prerequisites

experience with UNIX.



# CS 460/560 - Computer Graphics

**Credits:** 3

Laboratory work required. An introduction to graphical systems and methods. Topics include basic primitives, windowing, transformations, hardware, interaction devices, 3-D graphics, curved surfaces, solids, and realism techniques such as visible surface, lighting, shadows, and surface detail. Requires project involving OpenGL programming.


## Prerequisites

A grade of C or better in CS 361 .


### Immediate Prereqs

  * CS 361

### Indirect Prereqs

  * CS 150
  * CS 250
  * CS 252
  * CS 333
  * CS 361
  * MATH 102M or MATH 103M
  * MATH 162M
  * MATH 163


# CS 462/562 - Cybersecurity Fundamentals

**Credits:** 3

Introduction to networking and the Internet protocol stack; Vulnerable protocols such as HTTP, DNS, and BGP; Overview of wireless communications, vulnerabilities, and security protocols; Introduction to cryptography; Discussion of cyber threats and defenses; Firewalls and IDS/IPS; Kerberos; Transport Layer Security, including certificates; Network Layer Security.


## Prerequisites

MATH 162M .


### Immediate Prereqs

  * MATH 162M

### Indirect Prereqs

  * MATH 102M or MATH 103M
  * MATH 162M


# CS 463/563 - Cryptography for Cybersecurity

**Credits:** 3

This course covers mathematical foundations, including information theory, number theory, factoring, and prime number generation; cryptographic protocols, including basic building blocks and protocols; cryptographic techniques, including key generation and key management, and applications; and cryptographic algorithms--DES, AES, stream ciphers, hash functions, digital signatures, etc.


## Prerequisites

MATH 162M .


### Immediate Prereqs

  * MATH 162M

### Indirect Prereqs

  * MATH 102M or MATH 103M
  * MATH 162M


# CS 464/564 - Networked Systems Security

**Credits:** 3

Authentication in cyber systems including password-based, address-based, biometrics-based, and SSO systems; Authorization and accounting in cyber systems; Securing wired and wireless networks; Secured applications including secure e-mail services, secure web services, and secure e-commerce applications; Security and privacy in cloud environments.


## Prerequisites

MATH 162M .


### Immediate Prereqs

  * MATH 162M

### Indirect Prereqs

  * MATH 102M or MATH 103M
  * MATH 162M


# CS 465/565 - Information Assurance

**Credits:** 3

Introduction to information assurance. Topics to be covered include metrics, planning and deployment; identity and trust technologies; verification and evaluation, and incident response; human factors; regulation, policy languages, and enforcement; legal, ethical, and social implications; privacy and security trade-offs; system survivability; intrusion detection; and fault and security management.


## Prerequisites

MATH 162M and familiarity with computer security area.


### Immediate Prereqs

  * MATH 162M

### Indirect Prereqs

  * MATH 102M or MATH 103M
  * MATH 162M


# CS 471 - Operating Systems

**Credits:** 3

Laboratory work required. Operating system structures. Multiprogramming and multiprocessing. Process management. Memory and other resource management. Storage management, I/O systems, distributed systems. Protection and security. The concepts will be illustrated through example systems such as Unix and Windows.


## Prerequisites

A grade of C or better in CS 270 and CS 361 .


### Immediate Prereqs

  * CS 270
  * CS 361

### Indirect Prereqs

  * CS 150
  * CS 170
  * CS 250
  * CS 252
  * CS 270
  * CS 333
  * CS 361
  * MATH 102M or MATH 103M
  * MATH 162M
  * MATH 163


# CS 472 - Network and Systems Security

**Credits:** 3

Laboratory work required. Basic protocols, techniques and programming issues to secure network and computer systems. Topics include: cryptographic algorithms and concepts (Secret Key Cryptography, Hashes and Message Digests, Public Key and Authentication); Security Standards (Kerberos, Public Key Infrastructure, IPsec, SSL/TLS); Security applications (PEM, S/MIME, PGP, HTTP, Firewalls); Hands-on programming using OpenSSL.


## Prerequisites

A grade of C or better in CS 361 .


### Immediate Prereqs

  * CS 361

### Indirect Prereqs

  * CS 150
  * CS 250
  * CS 252
  * CS 333
  * CS 361
  * MATH 102M or MATH 103M
  * MATH 162M
  * MATH 163


# CS 475/575 - Introduction to Computer Simulation

**Credits:** 3

Laboratory work required. Efficient implementation methods. Time management. Planning and design of simulation experiments. Statistical issues in simulation. Generation of random numbers and stochastic variates. Programming with graphically- and text-based simulation languages. Verification and validation of simulation models. Distributed simulation. Special topics such as HLA will be discussed.


## Prerequisites

STAT 330 and a grade of C or better in CS 330 or CS 361 .


### Immediate Prereqs

  * CS 330
  * CS 361
  * STAT 330

### Indirect Prereqs

  * CS 150
  * CS 250
  * CS 252
  * CS 330
  * CS 333
  * CS 361
  * MATH 102M or MATH 103M
  * MATH 162M
  * MATH 163
  * STAT 330


# CS 476/576 - Systems Programming

**Credits:** 3

Laboratory work required. This course is to help students fully understand and utilize the internal workings and capabilities provided by modern computing, networking and programming environments. Topics include: Shell Script Programming, X Windows (Xlib and Motif), UNIX internals (I/O, Processes, Threads, IPC and Signals), Network Programming (UDP/TCP Sockets and Multicasting) and Java Systems Programming (SWING, Multithreading and Networking).


## Prerequisites

A grade of C or better in CS 330 and CS 361 .


### Immediate Prereqs

  * CS 330
  * CS 361

### Indirect Prereqs

  * CS 150
  * CS 250
  * CS 252
  * CS 330
  * CS 333
  * CS 361
  * MATH 102M or MATH 103M
  * MATH 162M
  * MATH 163


# CS 478/578 - Computational Geometry, Methods and Applications

**Credits:** 3

The discipline of Computational Geometry is devoted to the study of algorithms which are formulated in terms of spatially embedded arrangements of objects, such as points, lines, surfaces, and solids. This course covers fundamental algorithms including convex hulls, polygon triangulations, point location, Voronoi diagrams, Delaunaytriangulations, binary space partitions, quadtrees, and other topics.


## Prerequisites

CS 361 and MATH 211 .


### Immediate Prereqs

  * CS 361
  * MATH 211

### Indirect Prereqs

  * CS 150
  * CS 250
  * CS 252
  * CS 333
  * CS 361
  * MATH 102M or MATH 103M
  * MATH 162M
  * MATH 163
  * MATH 166
  * MATH 211


# CS 480/580 - Introduction to Artificial Intelligence

**Credits:** 3

Laboratory work required. Introduction to concepts, principles, challenges, and research in major areas of AI. Areas of discussion include: natural language and vision processing, machine learning, machine logic and reasoning, robotics, expert and mundane systems.


## Prerequisites

A grade of C or better in CS 361 .


### Immediate Prereqs

  * CS 361

### Indirect Prereqs

  * CS 150
  * CS 250
  * CS 252
  * CS 333
  * CS 361
  * MATH 102M or MATH 103M
  * MATH 162M
  * MATH 163


# CS 486/586 - Introduction to Parallel Computing

**Credits:** 3

Laboratory work required. The motivation for and successes of parallel computing. A taxonomy of commercially available parallel computers. Strategies for parallel decompositions. Parallel performance metrics. Parallel algorithms and their relation to corresponding serial algorithms. Numerous examples from scientific computing, mainly in linear algebra and differential equations. Implementations using public-domain network libraries on workstation clusters and computers.


## Prerequisites

MATH 316 ; knowledge of a high level language.


### Immediate Prereqs

  * MATH 316

### Indirect Prereqs

  * MATH 212
  * MATH 316


# CS 487 - Applied Parallel Computing

**Credits:** 3

Laboratory work required. Fundamental concepts of parallel computing: Machine models, architectures, parallel topologies and languages, parallel algorithm design and parallel programming, architecture independent message passing interface (MPI) communication library, and scaled-speedup. Group project required.


## Prerequisites

A grade of C or better in CS 270 and either CS 361 or CS 330 ; CS 417 or linear algebra is recommended.


### Immediate Prereqs

  * CS 270
  * CS 330
  * CS 361
  * CS 417

### Indirect Prereqs

  * CS 150
  * CS 170
  * CS 250
  * CS 252
  * CS 270
  * CS 330
  * CS 333
  * CS 361
  * CS 417
  * MATH 102M or MATH 103M
  * MATH 162M
  * MATH 163


# CS 488/588 - Principles of Compiler Construction

**Credits:** 3

Laboratory work required. Theoretical and practical aspects of compiler design and implementation. Topics will include lexical analysis, parsing, translation, code generation, optimization, and error handling.


## Prerequisites

A grade of C or better in CS 361 .


### Immediate Prereqs

  * CS 361

### Indirect Prereqs

  * CS 150
  * CS 250
  * CS 252
  * CS 333
  * CS 361
  * MATH 102M or MATH 103M
  * MATH 162M
  * MATH 163


# CS 495/595 - Topics in Computer Science

**Credits:** 1-3

Special topics.


## Prerequisites

permission of the instructor.



# CS 497/597 - Independent Study in Computer Science

**Credits:** 1-3

Independent study under the direction of an instructor.


## Prerequisites

permission of the instructor.


